% PostPriorPlots.m
lw = 2;
doeachplot = 0;
dosubplots = 1;

% Mean = 0.1, stdev = 2
a = 2.0025;
b = 0.10025;

burn_in = burn_in_para*N;

% Standard deviations

% 1. sig_r
xi_p1 = linspace(0,1,100);
p1 = invgam_pdf(xi_p1,a,b);
[f1,xi1] = ksdensity(xx_out(burn_in:end,1));
[~, pos] = max(f1);
xx_mode(1,1) = xi1(pos);

% 2. sig_a
xi_p2 = linspace(0,3,100);
p2 = invgam_pdf(xi_p2,2.25,1.25);
[f2,xi2] = ksdensity(xx_out(burn_in:end,2)); 
[~, pos] = max(f2);
xx_mode(1,2) = xi2(pos);

% 3. sig_e
xi_p3 = linspace(0,1,100);
p3 = invgam_pdf(xi_p3,a,b);
[f3,xi3] = ksdensity(xx_out(burn_in:end,3)); 
[~, pos] = max(f3);
xx_mode(1,3) = xi3(pos);

% 4. sig_z
xi_p4 = linspace(0,1,100);
p4 = invgam_pdf(xi_p4,a,b);
[f4,xi4] = ksdensity(xx_out(burn_in:end,4)); 
[~, pos] = max(f4);
xx_mode(1,4) = xi4(pos);

% 5. sig_target
xi_p5 = linspace(0,1,100);
p5 = invgam_pdf(xi_p5,a,b);
[f5,xi5] = ksdensity(xx_out(burn_in:end,5)); 
[~, pos] = max(f5);
xx_mode(1,5) = xi5(pos);

% 6. sig_eta
xi_p6 = linspace(0,1,100);
p6 = invgam_pdf(xi_p6,a,b);
[f6,xi6] = ksdensity(xx_out(burn_in:end,6)); 
[~, pos] = max(f6);
xx_mode(1,6) = xi6(pos);

% 7. mu
xi_p7 = linspace(0,3,100);
p7 = normpdf(xi_p7,1,0.5);
[f7,xi7] = ksdensity(xx_out(burn_in:end,7)); 
[~, pos] = max(f7);
xx_mode(1,7) = xi7(pos);


% Structural parameters 
% 8. rho_r
xi_p8 = linspace(0,1,100);
p8 = betapdf(xi_p8,5.065,5.065);
[f8,xi8] = ksdensity(xx_out(burn_in:end,8)); 
[~, pos] = max(f8);
xx_mode(1,8) = xi8(pos);


% 9. rho_pi 
xi_p9 = linspace(-.5,2,100);
p9 = normpdf(xi_p9,0.5,0.5);
[f9,xi9] = ksdensity(xx_out(burn_in:end,9)); 
[~, pos] = max(f9);
xx_mode(1,9) = xi9(pos);

% 10. rho_g
xi_p10 = linspace(-1,1,100);
p10 = normpdf(xi_p10,0.2,0.2);
[f10,xi10] = ksdensity(xx_out(burn_in:end,10)); 
[~, pos] = max(f10);
xx_mode(1,10) = xi10(pos);


% 11. rho_pi_f
xi_p11 = linspace(-.5,2,100);
p11 = normpdf(xi_p11,0.5,0.5);
[f11,xi11] = ksdensity(xx_out(burn_in:end,11)); 
[~, pos] = max(f11);
xx_mode(1,11) = xi11(pos);

% 12. rho_g_f
xi_p12 = linspace(-1,1,100);
p12 = normpdf(xi_p12,0.2,0.2);
[f12,xi12] = ksdensity(xx_out(burn_in:end,12)); 
[~, pos] = max(f12);
xx_mode(1,12) = xi12(pos);

% 13. rho_a
xi_p13 = linspace(0,1,100);
p13 = betapdf(xi_p13,5.065,5.065);
[f13,xi13] = ksdensity(xx_out(burn_in:end,13)); 
[~, pos] = max(f13);
xx_mode(1,13) = xi13(pos);

% 14. rho_e
xi_p14 = linspace(0,1,100);
p14 = betapdf(xi_p14,5.065,5.065);
[f14,xi14] = ksdensity(xx_out(burn_in:end,14)); 
[~, pos] = max(f14);
xx_mode(1,14) = xi14(pos);

% 15. rho_eta
xi_p15 = linspace(0,1,100);
p15 = betapdf(xi_p15,5.065,5.065);
[f15,xi15] = ksdensity(xx_out(burn_in:end,15)); 
[~, pos] = max(f15);
xx_mode(1,15) = xi15(pos);

% 16. rho_target
xi_p16 = linspace(0,1,100);
p16 = betapdf(xi_p16,5.065,5.065);
[f16,xi16] = ksdensity(xx_out(burn_in:end,16)); 
[~, pos] = max(f16);
xx_mode(1,16) = xi16(pos);

% 17. g_ss
xi_p17 = linspace(0,1,100);
p17 = unifpdf(xi_p17,0,2);
[f17,xi17] = ksdensity(xx_out(burn_in:end,17)); 
[~, pos] = max(f17);
xx_mode(1,17) = xi17(pos);

% 18. ppi_ss
xi_p18 = linspace(0,2,100);
p18 = unifpdf(xi_p18,0,2);
[f18,xi18] = ksdensity(xx_out(burn_in:end,18)); 
[~, pos] = max(f18);
xx_mode(1,18) = xi18(pos);


% 19. ppi_ss_f
xi_p19 = linspace(0,2,100);
p19 = unifpdf(xi_p19,0,2);
[f19,xi19] = ksdensity(xx_out(burn_in:end,19)); 
[~, pos] = max(f19);
xx_mode(1,19) = xi19(pos);


%% Figures

if doeachplot
    
figure('Name','Prior and Posterior: xx(1): sig_ea','NumberTitle','off')
plot(xi1,f1,'r',xi_p1,p1,'b:','LineWidth',lw);

figure('Name','Prior and Posterior: xx(2): sig_eb','NumberTitle','off')
plot(xi2,f2,'r',xi_p2,p2,'b:','LineWidth',lw);

figure('Name','Prior and Posterior: xx(3): sig_eg','NumberTitle','off')
plot(xi3,f3,'r',xi_p3,p3,'b:','LineWidth',lw);

figure('Name','Prior and Posterior: xx(4): sig_eqs','NumberTitle','off')
plot(xi4,f4,'r',xi_p4,p4,'b:','LineWidth',lw);

figure('Name','Prior and Posterior: xx(5): sig_em','NumberTitle','off')
plot(xi5,f5,'r',xi_p5,p5,'b:','LineWidth',lw);

figure('Name','Prior and Posterior: xx(6): sig_epinf','NumberTitle','off')
plot(xi6,f6,'r',xi_p6,p6,'b:','LineWidth',lw);

figure('Name','Prior and Posterior: xx(7): sig_ew','NumberTitle','off')
plot(xi7,f7,'r',xi_p7,p7,'b:','LineWidth',lw);

end


if dosubplots
    figure('Name','Priors and Posteriors - shocks') 
    subplot(3,3,1), plot(xi1,f1,'r',xi_p1,p1,'b:','LineWidth',lw), title('Sig_r')
    subplot(3,3,2), plot(xi2,f2,'r',xi_p2,p2,'b:','LineWidth',lw), title('Sig_a')
    subplot(3,3,3), plot(xi3,f3,'r',xi_p3,p3,'b:','LineWidth',lw), title('Sig_e')
    subplot(3,3,4), plot(xi4,f4,'r',xi_p4,p4,'b:','LineWidth',lw), title('Sig_z')
    subplot(3,3,5), plot(xi5,f5,'r',xi_p5,p5,'b:','LineWidth',lw), title('Sig_target')
    subplot(3,3,6), plot(xi6,f6,'r',xi_p6,p6,'b:','LineWidth',lw), title('Sig_eta')
    subplot(3,3,7), plot(xi7,f7,'r',xi_p7,p7,'b:','LineWidth',lw), title('mu')
     
    figure('Name','Priors and Posteriors - structural parameters') 
    subplot(3,4,1), plot(xi8,f8,'r',xi_p8,p8,'b:','LineWidth',lw), title('rho_r')
    subplot(3,4,2), plot(xi9,f9,'r',xi_p9,p9,'b:','LineWidth',lw), title('rho pi')
    subplot(3,4,3), plot(xi10,f10,'r',xi_p10,p10,'b:','LineWidth',lw), title('rho g')
    subplot(3,4,4), plot(xi11,f11,'r',xi_p11,p11,'b:','LineWidth',lw), title('rho pi f')
    subplot(3,4,5), plot(xi12,f12,'r',xi_p12,p12,'b:','LineWidth',lw), title('rho g f')
    subplot(3,4,6), plot(xi13,f13,'r',xi_p13,p13,'b:','LineWidth',lw), title('rho a')
    subplot(3,4,7), plot(xi14,f14,'r',xi_p14,p14,'b:','LineWidth',lw), title('rho e')
    subplot(3,4,8), plot(xi15,f15,'r',xi_p15,p15,'b:','LineWidth',lw), title('rho eta')
    subplot(3,4,9), plot(xi16,f16,'r',xi_p16,p16,'b:','LineWidth',lw), title('rho target')
    subplot(3,4,10), plot(xi17,f17,'r',xi_p17,p17,'b:','LineWidth',lw), title('g ss')
    subplot(3,4,11), plot(xi18,f18,'r',xi_p18,p18,'b:','LineWidth',lw), title('ppi ss')
    subplot(3,4,12), plot(xi19,f19,'r',xi_p19,p19,'b:','LineWidth',lw), title('ppi ss f')  
    
end